#ifndef TIMER_HH
#define TIMER_HH

/*
  James R. Diebel
  Stanford University
  
  Started: 27 August 2004
  Last revised: 27 Sugust 2004

  timer.hh - defines a Timer class that acts like a stop watch

  Depends on: nothing
*/

#include <time.h>
#include <iostream>

namespace bmtk {

using namespace std;

class Timer {
public:
  // Constructor/Destructor
  Timer();
  Timer(char* prefix_, char* suffix_);

  // Methods
  float read();
  float start();
  float stop();
  float glance();
  void reset();
  float peek();
  float store();
  void resetStore();
  void resetAll();
  float recall();
  float mark();
  float print();
  float printGlance();
  float printStore();
  float printStore(char* label);
  float printMark();
  float printMark(char* label);
  float printStop();
  float printStop(char* label);

private:
  // Data
  int startTime;
  int stopTime;
  int totalTime;
  int storeTime;
  char* prefix;
  char* suffix;
};

} // namespace bmtk

#endif
