/*
  James R. Diebel
  Stanford University

  Started: 6 June 2005
*/


#include <iostream>
#include "bmtk/mesh.hh"
#include "bmtk/timer.hh"
#include <trimesh/trimesh.h>

using namespace std;
using namespace bmtk;

int main (int argc, char *argv[]) {
  // if bad command line args, give usage instructions and exit
  if (argc < 3) {
    cout << endl
	 << "Usage: gts2msh infile.gts outfile.msh" << endl
	 << "    infile.gts must be a GTS file" << endl
	 << "    outfile.msh is the name of the output msh file" << endl;
    exit(1);
  }

  // create empty Mesh and then fill it with data from ply file
  Mesh m;
  m.buildFromGTS(argv[1]);

  // output it to the specified file
  m.writeMesh(argv[2]);

  return 0;
}


