/*
  James R. Diebel
  Stanford University

  Started: 24 August 2004
  Last revised:

  mesh_vert.cc - class implementation of Mesh class (mesh.hh)

  Depends on:
  - Mesh class (mesh.hh)
*/

#include "bmtk/mesh.hh"
#include <iostream>

namespace bmtk {

////////////////////////
// Per-Edge Functions //
////////////////////////
void Mesh::findEdgeLengths() {
  if (po) cout << "- Computing edge lengths..." << flush;
  for (int i=0;i<ne;i++) e[i].findLength();
  if (po) cout << "Done." << endl << flush;
}

void Mesh::findEdgeAngles() {
  if (po) cout << "- Computing edge angles..." << flush;
  for (int i=0;i<ne;i++) e[i].findAngle();
  if (po) cout << "Done." << endl << flush;
}

void Mesh::findEdgeProps() {
  if (po) cout << "- Computing edge properties..." << flush;
  for (int i=0;i<ne;i++) {
    e[i].findLength();
    e[i].findAngle();
  }
  if (po) cout << "Done." << endl << flush;
}

void Mesh::findEdgePotentials() {
  if (po) cout << "- Computing edge potentials..." << flush;
  bool temp = po;
  po = false;
  for (int i=0;i<ne;i++) {
    e[i].findPotential();
    e[i].flag = -1;
  }
  po = temp;
  if (po) cout << "Done." << endl << flush;
}

void Mesh::resetEdgeFlags() {
  if (po) cout << "- Reseting edge flags..." << flush;
  for (int i=0;i<ne;i++) e[i].flag = -1;
  if (po) cout << "Done." << endl << flush;
}

} // namespace bmtk
