/*
  James R. Diebel
  Stanford University
  
  Started: 18 January 2005

  off2msh.cc - Utility to convert a OFF file to a mesh (MSH) file

  Depends on:
  - Mesh class (mesh.hh)
  -- Vec3d class (vec3d.hh)
  -- Vert class (vert.hh)
  -- Edge class (edge.hh)
  -- Face class (face.hh)
  - Timer class (timer.hh)
  - TriMesh class (trimesh.h)
*/


#include <iostream>
#include "bmtk/mesh.hh"
#include "bmtk/timer.hh"
#include <trimesh/trimesh.h>

using namespace std;
using namespace bmtk;

int main (int argc, char *argv[]) {
  // if bad command line args, give usage instructions and exit
  if (argc < 3) {
    cout << endl 
	 << "Usage: om2msh infile.om outfile.msh" << endl
	 << "    infile.om must be a .OM file" << endl
	 << "    outfile.msh is the name of the output msh file" << endl;
    exit(1);
  }

  // create empty Mesh and then fill it with data from ply file
  Mesh m;
  int nv - 
  // parse TriMesh into standard vertex and face lists
  float* v = new float[3*nv];
  int* f = new int[3*nf];
  float tempFloat;
  for (int i=0;i<nv;i++) {
    for (int j=0;j<3;j++) {
      fin >> tempFloat;
      v[3*i+j] = tempFloat;
    }
  }
  for (int i=0;i<nf;i++) {
    fin >> tempInt;
    for (int j=0;j<3;j++) {
      fin >> tempInt;
      f[3*i+j] = tempInt;
    }
  }


  // output it to the specified file
  fm->writeMesh(argv[2]);
  //m.writeMesh(argv[2]);
  
  return 0;
}
